#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <sys/vfs.h>

void handler(int isig)
{
  write(1,"Alarm!\n",7);
  exit(1);
}

int main(int argc,char* argv[])
{
  char * dir;
  struct statfs s;
  int err;
  int childpid;
  int fd2[2];

  dir = ".";
  if (argv[1] != NULL)
    dir = argv[1];

  pipe(fd2);

  close(0);
  close(2);

  dup2(1,2);

  childpid = fork();

  if (childpid)
    {
      /* I am the parent */
      char buf[1024];
      int rd;

      signal(SIGALRM,handler);
      alarm(5);

      rd = read(fd2[0],buf,sizeof(buf));

      if (0)
        {
          printf("read %d, errno %d (%s)\n",rd,errno,strerror(errno));
        }

      if (rd > 0)
        write(1,buf,rd);

      exit(0);
    }

  close(1);
  dup2(fd2[1],1);
  dup2(fd2[1],2);

  setsid();

  err = statfs(dir,&s);
  printf("dir=%s\n",dir);
  if (err != 0)
    {
      printf("Error: %d, errno: %d (%s)\n",err,errno,strerror(errno));
      exit(1);
    }
  printf("f_type=%d\n",s.f_type);
  printf("f_bsize=%d\n",s.f_bsize);
  printf("f_blocks=%ld\n",s.f_blocks);
  printf("f_bfree=%ld\n",s.f_bfree);
  printf("f_bavail=%ld\n",s.f_bavail);
  printf("f_files=%ld\n",s.f_files);
  printf("f_ffree=%ld\n",s.f_ffree);
  /*printf("f_fsid=%d\n",s.f_fsid);*/
  printf("f_namelen=%d\n",s.f_namelen);
  exit(0);
}

/* end file */
